#ifndef MSP_IO_PIPE_H_
#define MSP_IO_PIPE_H_

#include "eventobject.h"
#include "handle.h"

namespace Msp {
namespace IO {

class Pipe: public EventObject
{
private:
	struct Private;

	Handle handle[2];
	Private *priv;

public:
	Pipe();
	~Pipe();

	void close();

	void set_block(bool);

protected:
	virtual unsigned do_write(const char *, unsigned);
	virtual unsigned do_read(char *, unsigned);

public:
	virtual const Handle &get_event_handle();
};

} // namespace IO
} // namespace Msp

#endif
